## srt 1.0.0

=== DESCRIPTION ===
Package: srt
Title: Read Subtitle Files as Tabular Data
Version: 1.0.0
Authors@R: 
    person(given = "Kiernan",
           family = "Nicholls",
           role = c("aut", "cre"),
           email = "kiernann@protonmail.com")
Description: Read 'SubRip' <https://sourceforge.net/projects/subrip/> 
    subtitle files as data frames for easy text analysis or manipulation. 
    Easily shift numeric timings and export subtitles back into valid 'SubRip' 
    timestamp format to sync subtitles and audio.
License: GPL-3
URL: https://github.com/kiernann/srt, https://kiernann.com/srt/
BugReports: https://github.com/kiernann/srt/issues
Suggests: covr (>= 3.5.1), testthat (>= 3.0.0), tibble (>= 3.0.4)
Encoding: UTF-8
LazyData: true
RoxygenNote: 7.1.1
NeedsCompilation: no
Packaged: 2020-11-27 02:17:26 UTC; kiernan
Author: Kiernan Nicholls [aut, cre]
Maintainer: Kiernan Nicholls <kiernann@protonmail.com>
Repository: CRAN
Date/Publication: 2020-11-30 08:50:03 UTC
