## srt 1.0.2

=== DESCRIPTION ===
Package: srt
Title: Read Subtitle Files as Tabular Data
Version: 1.0.2
Authors@R: 
    person(given = "Kiernan",
           family = "Nicholls",
           role = c("aut", "cre"),
           email = "kiernann@protonmail.com")
Description: Read 'SubRip'
    <https://sourceforge.net/projects/subrip/> subtitle files as data
    frames for easy text analysis or manipulation.  Easily shift numeric
    timings and export subtitles back into valid 'SubRip' timestamp format
    to sync subtitles and audio.
License: GPL-3
URL: https://github.com/kiernann/srt, https://kiernann.com/srt/
BugReports: https://github.com/kiernann/srt/issues
Suggests: covr (>= 3.5.1), spelling (>= 2.2), testthat (>= 3.0.0),
        tibble (>= 3.0.4)
Encoding: UTF-8
Language: en-US
LazyData: true
RoxygenNote: 7.1.1
NeedsCompilation: no
Packaged: 2021-02-16 19:15:28 UTC; kiernan
Author: Kiernan Nicholls [aut, cre]
Maintainer: Kiernan Nicholls <kiernann@protonmail.com>
Repository: CRAN
Date/Publication: 2021-02-16 19:40:02 UTC
