## srt 1.0.3

=== DESCRIPTION ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Package: srt
 Title: Read Subtitle Files as Tabular Data
-Version: 1.0.2
+Version: 1.0.3
 Authors@R: 
     person(given = "Kiernan",
            family = "Nicholls",
@@ -18,11 +18,10 @@
         tibble (>= 3.0.4)
 Encoding: UTF-8
 Language: en-US
-LazyData: true
 RoxygenNote: 7.1.1
 NeedsCompilation: no
-Packaged: 2021-02-16 19:15:28 UTC; kiernan
+Packaged: 2021-09-01 15:04:08 UTC; kiernan
 Author: Kiernan Nicholls [aut, cre]
 Maintainer: Kiernan Nicholls <kiernann@protonmail.com>
 Repository: CRAN
-Date/Publication: 2021-02-16 19:40:02 UTC
+Date/Publication: 2021-09-02 10:50:02 UTC
