## srt 1.0.4

=== DESCRIPTION ===
Package: srt
Title: Read Subtitle Files as Tabular Data
Version: 1.0.4
Authors@R: 
    person("Kiernan", "Nicholls", email = "k5cents@gmail.com", role = c("aut", "cre", "cph"),
           comment = c(ORCID = "0000-0002-9229-7897"))
Description: Read 'SubRip' <https://sourceforge.net/projects/subrip/>
    subtitle files as data frames for easy text analysis or manipulation.
    Easily shift numeric timings and export subtitles back into valid
    'SubRip' timestamp format to sync subtitles and audio.
License: GPL-3
URL: https://k5cents.github.io/srt/, https://github.com/k5cents/srt
BugReports: https://github.com/k5cents/srt/issues
Suggests: covr (>= 3.5.1), spelling (>= 2.2), testthat (>= 3.0.0),
        tibble (>= 3.0.4)
Encoding: UTF-8
Language: en-US
RoxygenNote: 7.2.3
NeedsCompilation: no
Packaged: 2024-03-11 14:13:02 UTC; kiernan
Author: Kiernan Nicholls [aut, cre, cph]
    (<https://orcid.org/0000-0002-9229-7897>)
Maintainer: Kiernan Nicholls <k5cents@gmail.com>
Repository: CRAN
Date/Publication: 2024-03-11 15:40:05 UTC
