=== debian/changelog ===
srt (1.3.1-1) unstable; urgency=medium

  * Initial release (Closes: #908333)

 -- Federico Ceratto <federico@debian.org>  Sun, 16 Sep 2018 17:27:04 +0100
