=== debian/changelog ===
srt (1.3.2-1) unstable; urgency=medium

  [ Ondřej Nový ]
  * Use 'python3 -m sphinx' instead of sphinx-build for building docs
  * d/control: Fix wrong Vcs-*

  [ Federico Ceratto ]
  * New upstream release
  * Split override_dh_installman (Closes: #914364)


 -- Federico Ceratto <federico@debian.org>  Fri, 17 May 2019 21:28:13 +0100
