=== debian/rules ===
--- 
+++ 
@@ -15,13 +15,15 @@
 
 override_dh_auto_build:
 	dh_auto_build
-	http_proxy='http://127.0.0.1:9/' sphinx-build -N -c debian -bhtml docs debian/html
+	http_proxy='http://127.0.0.1:9/' python3 -m sphinx -N -c debian -bhtml docs debian/html
 
 override_dh_auto_install:
 	dh_auto_install
-	cp debian/tmp/usr/bin/srt-live-transmit debian/tmp/usr/bin/stransmit
+	test -f debian/tmp/usr/bin/stransmit || cp debian/tmp/usr/bin/srt-live-transmit debian/tmp/usr/bin/stransmit
 
-override_dh_installman:
+override_dh_installman-indep:
+
+override_dh_installman-arch:
 	help2man --no-discard-stderr --no-info --version-string="$(DEB_VERSION)" \
 	--name "" \
 	-o ./debian/srt-file-transmit.1 ./debian/srt-tools/usr/bin/srt-file-transmit
