=== debian/changelog ===
srt (1.4.0-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:26:12 +0100

srt (1.4.0-1) unstable; urgency=medium

  * New upstream release (Closes: #939040)

 -- Federico Ceratto <federico@debian.org>  Tue, 17 Sep 2019 10:38:25 +0100
