=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: srt
 Priority: optional
 Maintainer: Federico Ceratto <federico@debian.org>
-Build-Depends: debhelper (>= 11~),
+Build-Depends: debhelper-compat (= 12),
  cmake,
  chrpath,
  help2man,
@@ -9,7 +9,7 @@
  pkg-config,
  python3-sphinx,
  tclsh
-Standards-Version: 4.2.1
+Standards-Version: 4.3.1
 Section: libs
 Homepage: https://github.com/Haivision/srt
 Vcs-Browser: https://salsa.debian.org/debian/libsrt
